import * as SERVER from '@minecraft/server';

SERVER.world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('xaierg:contaminate', {
        onRandomTick: e => spread(e.block),
        onPlayerDestroy: e => spread(e.block),
        onPlayerInteract: e => spread(e.block),
    });
});

function spread(block) {
  const blockTypes = ['xaierg:smile_fungus_inerte', 'xaierg:smile_fungus_flor', 'xaierg:smile_fungus_hearth', 'xaierg:smile_fungus_eye','xaierg:smile_fungus_veins_gen'];
  const randomBlockType = blockTypes[Math.floor(Math.random() * blockTypes.length)];

  const adjacentBlocks = [
    block.above(1),
    block.below(1),
    block.north(1),
    block.east(1),
    block.south(1),
    block.west(1)
  ];

  const chanceToSpreadDown = 0.05; // Probabilidad de propagarse hacia abajo

  adjacentBlocks.forEach(adjacentBlock => {
    if (adjacentBlock && !adjacentBlock.isAir && !['xaierg:smile_fungus_inerte', 'xaierg:smile_fungus_flor',
      'xaierg:smile_fungus_veins',
      'xaierg:smile_fungus_veins2',
      'xaierg:smile_fungus_veins_a',
      'xaierg:smile_fungus_veins_a2',
      'xaierg:smile_fungus_veins_b',
      'xaierg:smile_fungus_veins_b_2',
      'xaierg:smile_fungus_veins_b2',
      'xaierg:smile_fungus_veins_b2_2',
      'xaierg:smile_fungus_veins_b1',
      'xaierg:smile_fungus_veins_b1_2',
      'xaierg:smile_fungus_veins_c',
      'xaierg:smile_fungus_veins_c2','xaierg:smile_fungus_veins_gen',
       'xaierg:smile_fungus_hearth', 'xaierg:smile_fungus_eye'
    ].includes(adjacentBlock.typeId)) {
      if (adjacentBlock.location.y < block.location.y) { // Si es un bloque hacia abajo
        if (Math.random() < chanceToSpreadDown) { // Con probabilidad chanceToSpreadDown
          adjacentBlock.setType(Math.random() < 0.45 ? randomBlockType : 'xaierg:smile_fungus');
          block.setType('xaierg:smile_fungus_inerte'); // Reemplazar con el bloque inerte
        }
      } else {
        adjacentBlock.setType(Math.random() < 0.4 ? randomBlockType : 'xaierg:smile_fungus');
      } 
    }
  }); 
  block.dimension.getEntities({ location: block.location, maxDistance: 8 })
        .forEach(entity => {
            if (entity.typeId !== 'minecraft:player' && entity.typeId !== 'xaierg:smile_b' && entity.typeId !== 'xaierg:bomba_funcida' && entity.typeId !== 'xaierg:meteoro_smile2' && entity.typeId !== 'xaierg:riflef_m' && entity.typeId !== 'xaierg:riflef' && entity.typeId !=='xaierg:variant_c_smile7' && entity.typeId !== 'xaierg:lanzallamas_t' && entity.typeId !== 'xaierg:meteoro_smile' && entity.typeId !== 'xaierg:pist_m' && entity.typeId !== 'xaierg:pist' && entity.typeId !== 'xaierg:escopeta_m' && entity.typeId !== 'xaierg:escopeta' && entity.typeId !== 'xaierg:es_r_m' && entity.typeId !== 'xaierg:es_r' && entity.typeId !== 'xaierg:bala_npc' && entity.typeId !== 'xaierg:ametralladora' && entity.typeId !== 'xaierg:ametralladora_m' && entity.typeId !== 'xaierg:awm_m' && entity.typeId !== 'xaierg:awm' && entity.typeId !== 'xaierg:rifle' && entity.typeId !== 'xaierg:rifle_m' && entity.typeId !== 'xaierg:meteoro_smile' && entity.typeId !== 'xaierg:smiler_exploter' && entity.typeId !== 'xaierg:variant_c_smile6_child' && entity.typeId !== 'xaierg:variant_c_smile5_child' && entity.typeId !== 'xaierg:variant_c_smile4_child' && entity.typeId !== 'xaierg:variant_c_smile3_child'&& entity.typeId !== 'xaierg:variant_a_child' && entity.typeId !== 'xaierg:variant_a_smile_child' && entity.typeId !== 'xaierg:variant_a_smile2_child' && entity.typeId !== 'xaierg:variant_a_smile3_child' && entity.typeId !== 'xaierg:variant_a_smile4_child'&& entity.typeId !== 'xaierg:variant_a_death_child'&& entity.typeId !=='xaierg:variant_c_smile6' && entity.typeId !== 'xaierg:variant_c_smile5' && entity.typeId !== 'xaierg:variant_c_smile4' && entity.typeId !== 'xaierg:variant_c_smile3'&& entity.typeId !== 'xaierg:variant_a' && entity.typeId !== 'xaierg:variant_a_smile' && entity.typeId !== 'xaierg:variant_a_smile2' && entity.typeId !== 'xaierg:variant_a_smile3' && entity.typeId !== 'xaierg:variant_a_smile4'&& entity.typeId !== 'xaierg:variant_a_death'&& entity.typeId !== 'xaierg:smile_control' && entity.typeId !== 'xaierg:human_x' && entity.typeId !== 'minecraft:item') {
                block.dimension.spawnEntity('xaierg:smile_control', entity.location);
                entity.kill(); 
            } else if (entity.typeId === 'minecraft:item') {
                entity.kill();
            }
        });
  
}
function summonPig(block) {
                e.block.setType('minecraft:air')
    block.dimension.spawnEntity('minecraft:pig', block.location);
}

SERVER.world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('xaierg:spawn_torreta', { 
        onPlayerInteract: e => {
      e.player.runCommand(`structure load torreta ${e.block.location.x} ${e.block.location.y} ${e.block.location.z}`)
      
  }
 
    });
});
function summonTurret(block) {
                e.block.setType('minecraft:air')
    block.dimension.spawnEntity('xaierg:torreta', block.location);
}

SERVER.world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('xaierg:spawn_torreta_fire', { 
        onPlayerInteract: e => {
      e.player.runCommand(`structure load torreta_fire ${e.block.location.x} ${e.block.location.y} ${e.block.location.z}`)
      
  }
 
    });
});

function summonTurretfire(block) {
                e.block.setType('minecraft:air')
    block.dimension.spawnEntity('xaierg:torreta_fire', block.location);
}

SERVER.world.beforeEvents.worldInitialize.subscribe(initEvent => {
    initEvent.blockComponentRegistry.registerCustomComponent('xaierg:fungus_veins', { 
        onRandomTick: e => spreadGen(e.block), 
        onPlayerDestroy: e => spreadGen(e.block),
        onPlayerInteract: e => {
          e.player.runCommand(`function spore_sx`),
          spreadGen(e.block), 
          e.player.runCommand(`summon pig ${e.block.location.x} ${e.block.location.y} ${e.block.location.z}`)
          
      }
    });
});

function spreadGen(block) {
  const blockTypesv = [
    'xaierg:smile_fungus_veins',
    'xaierg:smile_fungus_veins2',
    'xaierg:smile_fungus_veins_a',
    'xaierg:smile_fungus_veins_a2',
    'xaierg:smile_fungus_veins_b',
    'xaierg:smile_fungus_veins_b_2',
    'xaierg:smile_fungus_veins_b2',
    'xaierg:smile_fungus_veins_b2_2',
    'xaierg:smile_fungus_veins_b1',
    'xaierg:smile_fungus_veins_b1_2',
    'xaierg:smile_fungus_veins_c',
    'xaierg:smile_fungus_veins_c2'
  ];

  const randomBlockType = blockTypesv[Math.floor(Math.random() * blockTypesv.length)];

  const adjacentBlocks = [
    block.above(1),
    block.north(1),
    block.east(1),
    block.south(1),
    block.west(1)
  ];

  adjacentBlocks.forEach(adjacentBlock => {
    if (adjacentBlock && adjacentBlock.isAir) {
      adjacentBlock.setType(randomBlockType);
     
    }
  });
  
  block.setType('xaierg:smile_fungus_inerte');
  block.dimension.getEntities({ location: block.location, maxDistance: 10 })
        .forEach(entity => {
            if ( entity.typeId !== 'xaierg:smile_b' && entity.typeId !== 'xaierg:meteoro_smile2' && entity.typeId !== 'xaierg:riflef_m' && entity.typeId !== 'xaierg:riflef' && entity.typeId !=='xaierg:variant_c_smile7' && entity.typeId !== 'xaierg:lanzallamas_t' && entity.typeId !== 'xaierg:meteoro_smile' && entity.typeId !== 'xaierg:pist_m' && entity.typeId !== 'xaierg:pist' && entity.typeId !== 'xaierg:escopeta_m' && entity.typeId !== 'xaierg:escopeta' && entity.typeId !== 'xaierg:es_r_m' && entity.typeId !== 'xaierg:es_r' && entity.typeId !== 'xaierg:bala_npc' && entity.typeId !== 'xaierg:ametralladora' && entity.typeId !== 'xaierg:ametralladora_m' && entity.typeId !== 'xaierg:awm_m' && entity.typeId !== 'xaierg:awm' && entity.typeId !== 'xaierg:rifle' && entity.typeId !== 'xaierg:rifle_m' && entity.typeId !== 'xaierg:meteoro_smile' && entity.typeId !== 'xaierg:smiler_exploter' && entity.typeId !== 'xaierg:variant_c_smile6_child' && entity.typeId !== 'xaierg:variant_c_smile5_child' && entity.typeId !== 'xaierg:variant_c_smile4_child' && entity.typeId !== 'xaierg:variant_c_smile3_child'&& entity.typeId !== 'xaierg:variant_a_child' && entity.typeId !== 'xaierg:variant_a_smile_child' && entity.typeId !== 'xaierg:variant_a_smile2_child' && entity.typeId !== 'xaierg:variant_a_smile3_child' && entity.typeId !== 'xaierg:variant_a_smile4_child'&& entity.typeId !== 'xaierg:variant_a_death_child'&& entity.typeId !=='xaierg:variant_c_smile6' && entity.typeId !== 'xaierg:variant_c_smile5' && entity.typeId !== 'xaierg:variant_c_smile4' && entity.typeId !== 'xaierg:variant_c_smile3'&& entity.typeId !== 'xaierg:variant_a' && entity.typeId !== 'xaierg:variant_a_smile' && entity.typeId !== 'xaierg:variant_a_smile2' && entity.typeId !== 'xaierg:variant_a_smile3' && entity.typeId !== 'xaierg:variant_a_smile4'&& entity.typeId !== 'xaierg:variant_a_death'&& entity.typeId !== 'xaierg:smile_control' && entity.typeId !== 'xaierg:human_x' && entity.typeId !== 'minecraft:item') {
                e.player.runCommand(`function spore_sx ${e.block.location.x} ${e.block.location.y} ${e.block.location.z}` );
            } else if (entity.typeId === 'minecraft:item') {
                entity.kill();
            }
        });
  
   // Reemplazar con el bloque inerte
}

SERVER.world.beforeEvents.worldInitialize.subscribe(initEvent => {
  initEvent.blockComponentRegistry.registerCustomComponent('xaierg:loot_normal', {
    onPlayerInteract: e => {
      e.player.runCommand(`structure load loot_normal ${e.block.location.x} ${e.block.location.y} ${e.block.location.z}`)
      
  } 
       });
});